<%@ page import="java.io.File"%>
<%@ page import="java.util.Collection"%>
<%@ page import="javax.security.auth.login.LoginContext"%>

<%@ page import="org.ow2.bonita.facade.ManagementAPI"%>
<%@ page import="org.ow2.bonita.facade.QueryDefinitionAPI"%>
<%@ page import="org.ow2.bonita.facade.RuntimeAPI"%>
<%@ page import="org.ow2.bonita.facade.QueryRuntimeAPI"%>
<%@ page import="org.ow2.bonita.facade.def.majorElement.ProcessDefinition"%>
<%@ page import="org.ow2.bonita.facade.uuid.ProcessDefinitionUUID"%>
<%@ page import="org.ow2.bonita.facade.uuid.ProcessInstanceUUID"%>
<%@ page import="org.ow2.bonita.util.AccessorUtil"%>
<%@ page import="org.ow2.bonita.util.Misc"%>
<%@ page import="org.ow2.bonita.util.SimpleCallbackHandler"%>

<%@ page import="org.ow2.bonita.facade.runtime.ActivityInstance"%>
<%@ page import="org.ow2.bonita.facade.runtime.ActivityState"%>
<%@ page import="org.ow2.bonita.facade.runtime.ProcessInstance"%>
<%@ page import="org.ow2.bonita.facade.runtime.TaskInstance"%>
<%@ page import="org.ow2.bonita.facade.uuid.ProcessInstanceUUID"%>
<%@ page import="org.ow2.bonita.facade.uuid.TaskUUID"%>
<%@ page import="org.ow2.bonita.util.BonitaRuntimeException"%>


<%
  final String processId = "ApprovalWorkflow";
  
  final String username = request.getParameter("username");
  final String password = request.getParameter("password");
  final String action = request.getParameter("Action");
  
  String msg = "";
  
  try {
    final LoginContext loginContext = new LoginContext("Bonita",
        new SimpleCallbackHandler(username, password));
    loginContext.login();

    final RuntimeAPI runtimeAPI = AccessorUtil.getRuntimeAPI();
    final QueryRuntimeAPI queryRuntimeAPI = AccessorUtil.getQueryRuntimeAPI();
    final ManagementAPI managementAPI = AccessorUtil.getManagementAPI();
    final QueryDefinitionAPI queryDefinitionAPI = AccessorUtil.getQueryDefinitionAPI();

    if (action.equals("Deploy")) {
      String barFile = request.getParameter("BarFile");
      final File file = new File(barFile);
      if (!file.exists()) {
        throw new Exception(
            "The given file : "
                + file
                + " does not exist. Are you sure you have generated the bar file ?");
      }
      final ProcessDefinition process = managementAPI.deployBar(Misc.getAllContentFrom(file)).get(processId);
      msg += "<br>Informations about deployment :";
      msg += "<br>Process Name : " + process.getName();
      msg += "<br>Process ID : " + process.getProcessId();
      msg += "<br>Process UUID : " + process.getUUID();

    } else if (action.equals("StartYes") || action.equals("StartNo")) {
      boolean isGranted = action.equals("StartYes");

      ProcessDefinition process = queryDefinitionAPI.getLastProcess(processId);
      ProcessDefinitionUUID processUUID = process.getUUID();

      //instantiation
      final ProcessInstanceUUID instanceUUID = runtimeAPI
          .instantiateProcess(process.getUUID());

      //tasks execution
      Collection<ActivityInstance<TaskInstance>> activities = queryRuntimeAPI
          .getTaskList(instanceUUID, ActivityState.READY);
      if (activities.isEmpty()) {
        throw new BonitaRuntimeException("No task found? Bad User?");
      }
      while (!activities.isEmpty()) {     
        for (ActivityInstance< TaskInstance > activity : activities) {
          final TaskUUID taskUUID = activity.getBody().getUUID();
          final String activityId = activity.getActivityId();
          log("Starting task associated to activity: " + activityId);
          runtimeAPI.startTask(taskUUID, true);
          if (activityId.equals("Approval")) {
            runtimeAPI.setActivityInstanceVariable(activity.getUUID(), "isGranted", isGranted);
          }
          log("Finishing task associated to activity: " + activityId);
          runtimeAPI.finishTask(taskUUID, true);
          log("Task associated to activity: " + activityId + " finished.");
        }
        activities = queryRuntimeAPI.getTaskList(instanceUUID, ActivityState.READY);
      }
      msg += "Instance " + instanceUUID + " successfully executed.";

    } else if (action.equals("Delete")) {
      ProcessDefinition process = queryDefinitionAPI.getLastProcess(processId);

      ProcessDefinitionUUID processUUID = process
          .getProcessDefinitionUUID();
      managementAPI.deleteProcess(processUUID);
      msg += "<br>Process with UUID " + processUUID
          + "  was succesully deleted";

    }

    loginContext.logout();
  } catch (Exception e1) {
    String stacktrace = Misc.getStackTraceFrom(e1);

    msg += "<div align='left'>";
    msg += e1.getMessage();
    msg += stacktrace.replaceAll("\n", "<br>");
    msg += Misc.getStackTraceFrom(e1);
    msg += "</div>";
  }
%>


<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
<HTML>
<HEAD>
<TITLE>Approval Workflow</TITLE>
</HEAD>
<BODY>
<div align='center'>
<h1>Approval Workflow</h1>
<br>
<br>

<%=msg%> <br>
<br>
<br>
<form name='form' method='get' action='actions.jsp'><input
	type='submit' value='BACK TO ACTIONS' name='back'> <input
	type='hidden' name='username' value='<%=username%>'> <input
	type='hidden' name='password' value='<%=password%>'></form>

</div>
</BODY>
</HTML>